//+------------------------------------------------------------------+
//|                                              ModifyFiboLines.mq4 |
//|                          Vladislav Shurkin, 31  2013 . |
//|    "-"   -|
//| (      , -|
//|  ,    , -|
//|   ,    ).       |
//|     .                       |
//+------------------------------------------------------------------+
#property copyright "Vladislav Shurkin, 31  2013 ."
#property link "vlad-755@mail.ru"
#property show_inputs
//+------------------------------------------------------------------+
//| .                                         |
//+------------------------------------------------------------------+
/*
         
(100  0)   FiboLines.
     ' '  
.

1000=10:
 - 100 -       100;
 - 0 -       0;
 - 10 ( ) -   .
 
100=0 -  100     
   (    ,
 - , 0 ( ) -   .

0=0 -  0     -
   (    ,
 - , 0 ( ) -   .

:
 - false ( ) -   ;
 - true -    ,    
    .

12 -     
         -
:
 - 1 -   ;
 - 2 -   ;
 - 12 -     ;
 - 0 ( ) -   .
 
=0.0 -     ,
    , 0.0 ( ) - -
  .

10=10:
 - 1 -     ;
 - 0 -      ;
 - 10 ( ) -   .

:       
 ,         FiboLines,
     ,    
        .
 
      ,   -
    .

         .
       "".

       
    ,      -
      .

       
 .       ShCuZ
 true   .   ShCuZ -
  .
*/
//+------------------------------------------------------------------+
//|  (    )           |
//+------------------------------------------------------------------+
extern int 1000=10;//  
extern int 100=0;//  100    
extern int 0=0;//  0    
extern bool ;//    
extern int 12;//  
extern double =0.0;//   
extern int 10=10;///  
extern string ="";//   
//+------------------------------------------------------------------+
//|                                       |
//+------------------------------------------------------------------+
bool ShCuZ=false;//     (false/true)
bool DrTkL; //    
bool ShPr;  //  
bool Vsb;   //     
bool Pnt0;  //  0
bool Pnt100;//  100
bool ObByNm;//    
datetime TmOD;//     
datetime Tm100,Tm100p;//    100%  FIBO
datetime Tm0,Tm0p; //    0%  FIBO
datetime Tm1Ln100,Tm2Ln100;//    1  2  TkLn100
datetime Tm1Ln0,Tm2Ln0;//    1  2  TkLn0
double PrOD; //     
double Pr100;//    100  FIBO
double Pr0;  //    0  FIBO
double m;    //, 
double AddLn;//   FIBO
double MnLn; //  0%  100%  FIBO
double PrN;  //   N  FIBO
int VrtPnt;  //1000
int MvPnt0;  //  0    
int MvPnt100;//  100    
int SvFstP;//  
int n;//, 
int z;// 
int u,j,i;// 
int CntFbL;//  FIBO-
int Err;// 
int ObjT;//    
int Prd;//      
int Shift;// ,    
int AsTm[7]={1,2,3,4,5,6,7};// 
int AsPr[7]={1,3,5,15,30,55,90};// 
string Txt,Txt1,Txt2;//Txt
string TxtExNm;// 
string Name,NameM;//  FIBO
string TkLn0,TkLn100;//  TkLn
//+------------------------------------------------------------------+
//| script program start function                                    |
//+------------------------------------------------------------------+
int start()
  {
Print(" ",WindowExpertName(),"     ",Symbol(),
" ",TimeToStr(TimeCurrent(),TIME_DATE|TIME_SECONDS));//
//====0= ====================================+
   VrtPnt=1000;//
   MvPnt100=100;//  100    
   MvPnt0=0;//  0    
   DrTkL=;//    
   SvFstP=12;//  
   AddLn=;//   
   ShPr=10;//  
   TmOD=WindowTimeOnDropped();//     
   PrOD=WindowPriceOnDropped();//     
   ObjT=ObjectsTotal();//       
   Prd=Period();//      
   TxtExNm=WindowExpertName();// 
   if(!="")ObByNm=true;//   
   if(ObByNm==true)NameM=;//  FIBO-
//====1=   ====================+
//----1-1-     -----------------------+
   if(TmOD==0 && PrOD==0 && ObByNm==false)//  0
   {
   Txt=StringConcatenate("    .\n   ",
   "          ",
   " 'Fibo-' (0  100).");//Txt
   PlaySound("Inform.wav");// 
   Print(Txt);//
   MessageBox(Txt,TxtExNm);//  
   return(0);//   , =0
   }// if(TmOD==0 && PrOD==0)
//----1-2-   -----------------------------+
   if(VrtPnt==10 && MvPnt0==0 && MvPnt100==0 && SvFstP==0 && DrTkL==0 
   && AddLn==0 && ShPr==10)//    ' '
   {
   Txt=StringConcatenate("  ",TxtExNm,"  . ",
   "\n    ' '.");//Txt
   PlaySound("Inform.wav");// 
   Print(Txt);//
   MessageBox(Txt,TxtExNm);//
   return(0);//   , =0
   }// if(VrtPnt==10 ...
//----1-3-    VrtPnt--------------+
   if(VrtPnt==0 || VrtPnt==10 || VrtPnt==100)z=0;//z- 
   else
   {
   Txt=StringConcatenate("  '1000'  ",
   VrtPnt,"  . \n   : 0, 10, 100. ",
   "\n  .");//Txt
   PlaySound("Inform.wav");// 
   Print(Txt);//
   MessageBox(Txt,TxtExNm);//
   return(0);//   , =0
   }// else
//----1-4-    SvFstP--------------+
   if(SvFstP==0 || SvFstP==1 || SvFstP==2 || SvFstP==12)z=0;//z- 
   else
   {
   Txt=StringConcatenate("  '12'  ",
   SvFstP,"  . \n   : 0, 1, 2, 12. ",
   "\n  .");//Txt
   PlaySound("Inform.wav");// 
   Print(Txt);//
   MessageBox(Txt,TxtExNm);//
   return(0);//   , =0
   }// else   
//----1-5-     -+
   if(AddLn>10)// - > 10
   {
   Txt=StringConcatenate("   - > 10. ",
   "\n","   : ",
   "\n0.118, 0.786, 1.118, 1.272, 1.382, 1.764, 1.882  .. ",
   "\n  .");//Txt
   PlaySound("Inform.wav");// 
   Print(Txt);//
   MessageBox(Txt,TxtExNm);//
   return(0);//   , =0
   }// if(AddLn>10)
//----1-6-    ShPr----------------+
   if(ShPr==0 || ShPr==1 || ShPr==10)z=0;//z- 
   else
   {
   Txt=StringConcatenate("  '10'  ",
   ShPr,"  . \n   : 0, 1, 10. ",
   "\n  .");//Txt
   PlaySound("Inform.wav");// 
   Print(Txt);//
   MessageBox(Txt,TxtExNm);//
   return(0);//   , =0
   }// else
//====2=  ==============================+
   if(ObByNm==false)//   
   {
//----2-1-     ----------------+
   if(ShCuZ==true)//
    {
   ObjectCreate("CP",OBJ_ELLIPSE,0,TmOD-Prd*60,PrOD,TmOD+Prd*60,PrOD);//
   Err=GetLastError();// 
   if(Err>0 && Err!=4200)Print("#FunDrTkL-ErrTREND=",Err);// 
   if(Err==4200)//  
     {
   if(ObjectDelete("CP")!=true)//  CP
   Print("#CP-ErrObjectDelete=",GetLastError());// 
   if(ObjectCreate("CP",OBJ_ELLIPSE,0,TmOD-Prd*60,PrOD,TmOD+Prd*60,PrOD)!=true)//
   Print("#CP-ErrObjectCreate=",GetLastError());// 
     }// if(Err==4200)
   if(ObjectSet("CP",OBJPROP_COLOR,Red)!=true)//   
   Print("#CP-ErrSetCOLOR=",GetLastError());// 
   if(ObjectSet("CP",OBJPROP_SCALE,1)!=true)//   
   Print("#CP-ErrSetSCALE=",GetLastError());// 
   if(ObjectSet("CP",OBJPROP_BACK,0)!=true)//    
   Print("#CP-ErrSetBACK=",GetLastError());// 
   if(ObjectSet("CP",OBJPROP_WIDTH,5)!=true)//   
   Print("#CP-ErrSetWIDTH=",GetLastError());// 
   ObjectSetText("CP","  ",10,"Arial",CLR_NONE);// CP
   Err=GetLastError();if(Err>0)Print("ObjectSetTextCP=",Err);// 
   WindowRedraw();//   
   Print("  : Tm=",
   TimeToStr(TmOD,TIME_DATE|TIME_MINUTES),", Pr=",PrOD);//
    }// if(ShCuZ==true)
//----2-2-   -----------------------------+
   for(u=0;u<7;)// u
    {
   if(CntFbL>0)break;// ,    u
   for(j=0;j<7;)// j
     {
   if(CntFbL>0)break;// ,    j
   n=AsTm[u];//  
   if(Digits==3 || Digits==5)m=AsPr[j]*Point*10;//  
   else m=AsPr[j]*Point;//  
//----2-2-1-     ---------------+
   if(ShCuZ==true)//
    {
   ObjectCreate("RA",OBJ_RECTANGLE,0,TmOD-n*Prd*60,PrOD-m,
   TmOD+n*Prd*60,PrOD+m);//
   Err=GetLastError();// 
   if(Err>0 && Err!=4200)Print("#FunDrTkL-ErrTREND=",Err);// 
   if(Err==4200)//  
     {
   if(ObjectDelete("RA")!=true)//  RA
   Print("#RA-ErrObjectDelete=",GetLastError());// 
   if(ObjectCreate("RA",OBJ_RECTANGLE,0,TmOD-n*Prd*60,PrOD-m,
   TmOD+n*Prd*60,PrOD+m)!=true)//
   Print("#RA-ErrObjectCreate=",GetLastError());// 
     }// if(Err==4200)
   if(ObjectSet("RA",OBJPROP_COLOR,Yellow)!=true)//   
   Print("#RA-ErrSetCOLOR=",GetLastError());// 
   if(ObjectSet("RA",OBJPROP_BACK,0)!=true)//    
   Print("#RA-ErrSetBACK=",GetLastError());// 
   WindowRedraw();//   
   Sleep(1500);//
    }// if(ShCuZ==true)
//----2-2-2-  ----------------------------+
   for(i=0;i<ObjT;i++)//   
     {
   Name=ObjectName(i);// 
   Err=GetLastError();if(Err>0)Print("#21-",i,"-ErrObjectName=",Err);// 
   if(ObjectType(Name)!=OBJ_FIBO)//  ...
      {
   Err=GetLastError();if(Err>0)Print("#21-",i,"-ObjectType=",Err);// 
   continue;//...
      }
   Tm100=ObjectGet(Name,OBJPROP_TIME1);//   ( 100)
   Err=GetLastError();if(Err>0)Print("#21-",i,"-ErrTIME1=",Err);// 
   Pr100=ObjectGet(Name,OBJPROP_PRICE1);//   ( 100)
   Err=GetLastError();if(Err>0)Print("#21-",i,"-ErrPRICE1=",Err);// 
   Tm0=ObjectGet(Name,OBJPROP_TIME2);//   ( 0)
   Err=GetLastError();if(Err>0)Print("#21-",i,"-ErrTIME2=",Err);//    
   Pr0=ObjectGet(Name,OBJPROP_PRICE2);//   ( 0)
   Err=GetLastError();if(Err>0)Print("#21-",i,"-ErrPRICE2=",Err);// 
//----2-2-3-  --------------------------------+
if((Tm100<TmOD+n*Prd*60 && Tm100>TmOD-n*Prd*60) || (Tm0<TmOD+n*Prd*60 && Tm0>TmOD-n*Prd*60) &&
(Pr100<PrOD+m && Pr100>PrOD-m) || (Pr0<PrOD+m && Pr0>PrOD-m))//
       {
   NameM=Name;//   FIBO-
   CntFbL++;//  FIBO-
   Vsb=ObjectGet(NameM,OBJPROP_TIMEFRAMES);//  
   Err=GetLastError();if(Err>0)Print("#31-",i,"-ErrTIMEFRAMES=",Err);//    
   if(Vsb==0)//   
        {
   Print("  ",i," - ",NameM);//
   Print("   ",NameM,": Tm100=",TimeToStr(Tm100,TIME_DATE|TIME_MINUTES),
   " Pr100=",Pr100," Tm0=",TimeToStr(Tm0,TIME_DATE|TIME_MINUTES)," Pr0=",Pr0);//
        }// if(Vsb==0)
   else 
        {
   Print("  ",i," - ",NameM," (   )");//
   Print(" ",NameM,": Tm100=",TimeToStr(Tm100,TIME_DATE|TIME_MINUTES),
   " Pr100=",Pr100," Tm0=",TimeToStr(Tm0,TIME_DATE|TIME_MINUTES)," Pr0=",Pr0);//
        }// else
       }// if((Tm100<TmOD+Prd*60 && Tm100>TmOD-Prd*60))...
      }// for(i=0;i<ObjT;i++)
   u++;// u
   j++;// j
     }// for(j=0;j<7;)
    }// for(u=0;u<7;)
   if(ShCuZ==true)//   
    {
   ObjectSetText("RA","  ",10,"Arial",CLR_NONE);// CP
   Err=GetLastError();if(Err>0)Print("ObjectSetTextRA=",Err);// 
    }// if(ShCuZ==true)
//----2-3-      Fibo------------+
   if(CntFbL==0)//  Fibo-
    {
   Txt1=StringConcatenate("   ",TimeToStr(TmOD-n*Prd*60,TIME_DATE|TIME_MINUTES),
   " - ",TimeToStr(TmOD+n*Prd*60,TIME_DATE|TIME_MINUTES),"   ",PrOD-m,
   " - ",PrOD+m,"    'Fibo-' .");//Txt1
   Txt2=StringConcatenate("\n      ",
   "        'Fibo-' (0  100).");//Txt2
   Txt=StringConcatenate(Txt1,Txt2);//Txt
   PlaySound("Inform.wav");// 
   Print(Txt1);Print(Txt2);//  
   MessageBox(Txt,TxtExNm);//
    }// if(CntFbL==0)
//----2-4-      Fibo-----+
   if(CntFbL>1)//        Fibo-
    {
   Txt=StringConcatenate("   ",TimeToStr(TmOD-n*Prd*60,TIME_DATE|TIME_MINUTES),
   " - ",TimeToStr(TmOD+n*Prd*60,TIME_DATE|TIME_MINUTES),"   ",PrOD-m,
   " - ",PrOD+m,"   ",CntFbL,"-  'Fibo-'. ",
   "\n    . ",
   "\n     .");//Txt
   PlaySound("Inform.wav");// 
   Print(Txt);//  
   MessageBox(Txt,TxtExNm);//  
    }// if(CntFbL>1)
   }// if(ObByNm==false)
//====3=  ===============================+
   if(CntFbL==1 || ObByNm==true)//   Fibo-    
    {
//----3-1-  ------------------------------+
   Tm100=ObjectGet(NameM,OBJPROP_TIME1);//   ( 100)
   Err=GetLastError();
   if(Err==4202)
     {
   Txt=StringConcatenate("   ",NameM,"   ",Symbol(),
   "  . ","\n       Fibo",
   "\n    ''.");//Txt
   PlaySound("Inform.wav");// 
   Print(Txt);//
   MessageBox(Txt,TxtExNm);//  
   return(0);//   , =0
     }// if(Err==4202)
   if(Err>0)Print("#31-ErrGetTIME1=",Err);// 
   Tm100p=Tm100;//    ( 100)
   Tm0=ObjectGet(NameM,OBJPROP_TIME2);//   ( 0)
   Err=GetLastError();if(Err>0)Print("#31-ErrGetTIME2=",Err);// 
   Tm0p=Tm0;//    ( 0)
   Pr100=ObjectGet(NameM,OBJPROP_PRICE1);//   ( 100)
   Err=GetLastError();if(Err>0)Print("#31-ErrGetPRICE1=",Err);// 
   Pr0=ObjectGet(NameM,OBJPROP_PRICE2);//   ( 0)
   Err=GetLastError();if(Err>0)Print("#31-ErrGetPRICE2=",Err);// 
//----3-2-      100------+
   if(VrtPnt==100)//
    {
   Tm0=Tm100;// Tm0
   if(ObjectSet(NameM,OBJPROP_TIME2,Tm0)!=true)// 2-  
   Print("#32-ErrSetTIME2=",GetLastError());// 
   Print(" ",NameM,"     100");//
   if(DrTkL==true)//
     {
   Pnt0=true;FunDrTkL();//   
     }// if(DrTkL==true)
    }// if(VrtPnt==100)
//----3-3-      0--------+
   if(VrtPnt==0)//
    {
   Tm100=Tm0;// Tm100
   if(ObjectSet(NameM,OBJPROP_TIME1,Tm100)!=true)// 1-  
   Print("#33-ErrSetTIME1=",GetLastError());// 
   Print(" ",NameM,"     0");//
   if(DrTkL==true)//
     {
   Pnt100=true;FunDrTkL();//   
     }// if(DrTkL==true)
    }// if(VrtPnt==0)
//----3-4-  100    --------------------+
   if(MvPnt100!=0)//
    {
   Shift=iBarShift(Symbol(),0,Tm100,false);//   
   if(Shift<MvPnt100)
     {
   Print(" 100  ",NameM,"     ",Shift,
   " (),   ",MvPnt100,".   ...");//
   MvPnt100=Shift;// MvPnt0
     }// if(Shift<MvPnt100)
   Tm100=iTime(NULL,0,Shift-MvPnt100);//Tm100
   if(ObjectSet(NameM,OBJPROP_TIME1,Tm100)!=true)//     100
   Print("#34-ErrSetTIME1=",GetLastError());// 
   Print(" 100  ",NameM,"   ",MvPnt100," ()");//
   if(DrTkL==true)//
     {
   Pnt100=true;FunDrTkL();//   
     }// if(DrTkL==true)
    }// if(MvPnt100!=0)
//----3-5-  0    ----------------------+
   if(MvPnt0!=0)//
    {
   Shift=iBarShift(Symbol(),0,Tm0,false);//   
   if(Shift<MvPnt0)//
     {
   Print(" 0  ",NameM,"     ",Shift,
   " (),   ",MvPnt0,".   ...");//
   MvPnt0=Shift;// MvPnt0
     }// if(Shift<MvPnt0)
   Tm0=iTime(NULL,0,Shift-MvPnt0);//Tm0
   if(ObjectSet(NameM,OBJPROP_TIME2,Tm0)!=true)//    0
   Print("#35-ErrSetTIME2=",GetLastError());// 
   Print(" 0  ",NameM,"   ",MvPnt0," ()");//
   if(DrTkL==true)//
     {
   Pnt0=true;FunDrTkL();//   
     }// if(DrTkL==true)
//Print("35 "," MvPnt0=",MvPnt0," Shift=",Shift," Tm0=",Tm0," Pnt0=",Pnt0);//
    }// if(MvPnt0!=0)
//----3-6-     -----------+
   if(SvFstP==1 || SvFstP==2 || SvFstP==12)//
   {
   Txt=ObjectDescription(NameM);// 
   Print("   ",NameM,": ",Txt);//
   if(SvFstP==1)Txt=StringConcatenate("T1=",TimeToStr(Tm100p,TIME_DATE|TIME_MINUTES),
   " T2=",TimeToStr(Tm0p,TIME_DATE|TIME_MINUTES));//Txt
   if(SvFstP==2)Txt=StringConcatenate("P1=",Pr100," P2=",Pr0);//Txt
   if(SvFstP==12)Txt=StringConcatenate("T1=",TimeToStr(Tm100p,TIME_DATE|TIME_MINUTES),
   " P1=",Pr100," T2=",TimeToStr(Tm0p,TIME_DATE|TIME_MINUTES)," P2=",Pr0);//Txt
   if(ObjectSetText(NameM,Txt,10,"Arial",CLR_NONE)!=true)//  
   Print("#36-ErrSetText=",GetLastError());// 
   Print("   ",NameM,": ",Txt);//
   }
//----3-7-   ------------------+
   if(AddLn!=0)//     
   {
//----3-7-1-- ...--------------------------------------+
    for(i=0;i<32;i++)// 
    {
   if(AddLn==ObjectGet(NameM,OBJPROP_FIRSTLEVEL+i))//    
     {
   Err=GetLastError();if(Err>0)Print("#371-ObjectGet=",GetLastError());// 
   Print("  ",AddLn,"   ",NameM,
   "  , ..      ",i+1);//
   AddLn=0;//     
   break;//   for
     }// if(AddLn==ObjectGet(NameM,OBJPROP_FIRSTLEVEL+i))   
   Txt=ObjectGetFiboDescription(NameM,i);//    ,  32
   if(GetLastError()!=0) break;//   for
//Print("371 ",NameM,"  : ",i," : ",Txt);//371
    }// for(i=0;i<32;i++)
   }// if(AddLn!=0)
//----3-7-2-  ----------------------------------+
   if(AddLn!=0)//     
   {
   if(ObjectSet(NameM,OBJPROP_FIBOLEVELS,i+1)!=true)//   Fibo
   Print("#372-ErrFIBOLEVELS=",GetLastError());// 
   if(ObjectSet(NameM,OBJPROP_FIRSTLEVEL+i,AddLn)!=true)// n-  Fibo
   Print("#372-ErrFIRSTLEVEL+i=",GetLastError());// 
   else Txt=DoubleToStr(AddLn*100,1);//Txt
   if(ObjectSetFiboDescription(NameM,i,Txt)!=true)//   
   Print("#372-ErrSetFiboDescription=",GetLastError());// 
   else
    {
   Txt=ObjectGetFiboDescription(NameM,i);//   
   Print("  ",NameM,"    ",i+1,",  ~ ",Txt);//
    }// else
   }// if(AddLn!=0)
//----3-8-/  -----------------------------+
   if(ShPr==1 || ShPr==0)//
    {
   for(n=0;n<32;n++)
     {
   MnLn=ObjectGet(NameM,OBJPROP_FIRSTLEVEL+n);//   Fibo   n
   if(GetLastError()!=0) break;//    
   PrN=NormalizeDouble(Pr0+(Pr100-Pr0)*MnLn,Digits);//  
   if(ShPr==0)//
   Txt=DoubleToStr(MnLn*100,1);//Txt
   if(ShPr==1)//
   Txt=StringConcatenate(DoubleToStr(PrN,Digits),"~",DoubleToStr(MnLn*100,1));//Txt
   if(ObjectSetFiboDescription(NameM,n,Txt)!=true)//   
   Print("#38-ErrSetFiboDescription=",GetLastError());// 
     }// for(n=0;n<32;n++)
   if(ShPr==1)Print("      ",NameM);//
   if(ShPr==0)Print("     ",NameM," ");//
    }// if(ShPri==true)
//====4=ר  =========================================+
   WindowRedraw();//   
   Print("   ",NameM,
   ": Tm100=",TimeToStr(Tm100,TIME_DATE|TIME_MINUTES)," Pr100=",Pr100,
   " Tm0=",TimeToStr(Tm0,TIME_DATE|TIME_MINUTES)," Pr0=",Pr0);//
   Txt1=StringConcatenate(" ",TxtExNm,"    ",Symbol(),
   "  ",TimeToStr(TimeCurrent(),TIME_DATE|TIME_SECONDS));//Txt1
   Txt2=("\n    .");//Txt2
   Txt=Txt1+Txt2;//Txt
   PlaySound("Inform.wav");// 
//   Comment(Txt);//
   Print(Txt1);//
   MessageBox(Txt,TxtExNm);//
   }// if(CntFbL==1)
   return(0);//   , =0
  }
//+------------------------------------------------------------------+
//|    void FunDrTkL()                    |
//+------------------------------------------------------------------+
void FunDrTkL()
   {
   if((VrtPnt==0 || MvPnt100!=0) && Pnt100==true)//  100
    {
   TkLn100=StringConcatenate("TkLn100 ",NameM);//  100  
   ObjectCreate(TkLn100,OBJ_TREND,0,Tm100p,Pr100,Tm100,Pr100);// 
   Err=GetLastError();if(Err>0 && Err!=4200)Print("#FunDrTkL-ErrTREND=",Err);// 
   if(Err==4200)//4200 -    
     {
   ObjectSet(TkLn100,OBJPROP_TIME2,Tm100);//   
   Err=GetLastError();if(Err>0)Print("#FunDrTkL-ErrSetTIME2=",Err);// 
     }// if(Err==4200)
   ObjectSet(TkLn100,OBJPROP_RAY,0);//   
   Err=GetLastError();if(Err>0)Print("#FunDrTkL-ErrSetRAY=",Err);// 
   Tm1Ln100=ObjectGet(TkLn100,OBJPROP_TIME1);//   TkLn100
   Tm2Ln100=ObjectGet(TkLn100,OBJPROP_TIME2);//   TkLn100
   Txt=StringConcatenate("Tm1Ln100 ",TimeToStr(Tm1Ln100,TIME_DATE|TIME_MINUTES),
   "; Tm2Ln100 ",TimeToStr(Tm2Ln100,TIME_DATE|TIME_MINUTES));//Txt
   ObjectSetText(TkLn100,Txt,10,"Arial",CLR_NONE);//  TkLn100
   Err=GetLastError();if(Err>0)Print("#FunDrTkL100-ObjectSetText=",Err);// 
   Pnt100=false;//    100 
   Print("    100  : ",
   " Tm1Ln100=",TimeToStr(Tm1Ln100,TIME_DATE|TIME_MINUTES),
   " Tm2Ln100=",TimeToStr(Tm2Ln100,TIME_DATE|TIME_MINUTES)," Pr=",Pr100);//
    }// if(VrtPnt==0 || MvPnt0!=)
//----
   if((VrtPnt==100 || MvPnt0!=0) && Pnt0==true)//  0
    {
   TkLn0=StringConcatenate("TkLn0 ",NameM);//  0  
   ObjectCreate(TkLn0,OBJ_TREND,0,Tm0p,Pr0,Tm0,Pr0);// 
   Err=GetLastError();if(Err>0 && Err!=4200)Print("#FunDrTkL-ErrTREND=",Err);// 
   if(Err==4200)//4200 -    
     {
   ObjectSet(TkLn0,OBJPROP_TIME2,Tm0);//   
   Err=GetLastError();if(Err>0)Print("#FunDrTkL-ErrSetTIME2=",Err);// 
     }// if(Err==4200)
   ObjectSet(TkLn0,OBJPROP_RAY,0);//   
   Err=GetLastError();if(Err>0)Print("#FunDrTkL-ErrSetRAY=",Err);// 
   Tm1Ln0=ObjectGet(TkLn0,OBJPROP_TIME1);//   TkLn0
   Tm2Ln0=ObjectGet(TkLn0,OBJPROP_TIME2);//   TkLn0
   Txt=StringConcatenate("Tm1Ln0 ",TimeToStr(Tm1Ln0,TIME_DATE|TIME_MINUTES),
   "; Tm2Ln0 ",TimeToStr(Tm2Ln0,TIME_DATE|TIME_MINUTES));//Txt
   ObjectSetText(TkLn0,Txt,10,"Arial",CLR_NONE);//  TkLn0
   Err=GetLastError();if(Err>0)Print("#FunDrTkL0-ObjectSetText=",Err);// 
   Pnt0=false;//    0 
   Print("    0  : ",
   " Tm1Ln0=",TimeToStr(Tm1Ln0,TIME_DATE|TIME_MINUTES),
   " Tm2Ln0=",TimeToStr(Tm2Ln0,TIME_DATE|TIME_MINUTES)," Pr=",Pr0);//
    }// if(VrtPnt==100 || MvPnt100!=0)
   return;//   
   }// FunDrTkL()
//+------------------------------------------------------------------+